// Vesmir.cpp: implementation of the CVesmir class.
//
//////////////////////////////////////////////////////////////////////

#include "Vesmir.h"
#include <math.h>
#include <stdio.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

char err[255];
double vel_vekt(double x, double y,double z)
{ return sqrt(x*x+y*y+z*z);}

/**************************
CVesmir::CVesmir()
{
	celkemt=0; deltat=0.005; kapa=0.01;
	Planety[0].pol.x=Planety[0].pol.y=Planety[0].pol.z=0;
	Planety[0].rych=Planety[0].pol;
	Planety[0].m=Planety[0].r=Planety[0].rot=Planety[0].osa_rot=0;
	Planety[0].meno[0]=0;
	for (int i=1; i<poc_planet; i++) Planety[i]=Planety[i-1];

	deltat=0.5;
	strcpy( Planety[0].meno,"Vesmir");	strcpy( Planety[0].soubor,"Data/planety_256x128x24/Spacea.bmp");
	strcpy( Planety[1].meno,"Slunce");	strcpy( Planety[1].soubor,"Data/planety_256x128x24/0Sun.bmp");
	strcpy( Planety[2].meno,"Jupiter");	strcpy( Planety[2].soubor,"Data/planety_256x128x24/5Jupiter.bmp");
	strcpy( Planety[3].meno,"Saturn");	strcpy( Planety[3].soubor,"Data/planety_256x128x24/6Saturn.bmp");

	//0 Vesmir
	Planety[0].r=5000; Planety[0].m=1;

	//1 Slunce
	Planety[1].r=10;
	Planety[1].m=800;
	Planety[1].osa_rot=0;
	Planety[1].rot=5;

	TPlanety p1, p2=Planety[1];

	//2 Jupiter
	p1=Planety[2];
	p1.r=5;
	p1.m=10;
	p1.pol.z=-100;
	p1.rych.x=p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=0;
	p1.rot=5;
	Planety[2]=p1;

	p2=Planety[2];
	//3 Saturn
	p1=Planety[3];
	p1.r=0.5;
	p1.m=5;
	p1.pol.z=-110;
	p1.rych.x=p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.rych.x+=p2.rych.x*1.1;
	p1.osa_rot=0;
	p1.rot=5;
	Planety[3]=p1;

	// uz je zadana hmotnost p2..p10
//	p1=Planety[2]; Planety[1].rych.x=-p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
//	p1=Planety[3]; Planety[1].rych.x=+p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
}
**************************/
//**************************
CVesmir::CVesmir()
{
	celkemt=0; deltat=0.005; kapa=0.01;
	Planety[0].pol.x=Planety[0].pol.y=Planety[0].pol.z=0;
	Planety[0].rych=Planety[0].pol;
	Planety[0].m=Planety[0].r=Planety[0].rot=Planety[0].osa_rot=0;
	Planety[0].meno[0]=0;
	for (int i=1; i<poc_planet; i++) Planety[i]=Planety[i-1];

	strcpy( Planety[0].meno,"Vesmir");	strcpy( Planety[0].soubor,"Data/planety_256x128x24/Spacea.bmp");
	strcpy( Planety[1].meno,"Slunce");	strcpy( Planety[1].soubor,"Data/planety_256x128x24/0Sun.bmp");
	strcpy( Planety[2].meno,"Merkur");	strcpy( Planety[2].soubor,"Data/planety_256x128x24/1Mercury.bmp");
	strcpy( Planety[3].meno,"Venuse");	strcpy( Planety[3].soubor,"Data/planety_256x128x24/2Venus.bmp");
	strcpy( Planety[4].meno,"Zeme");	strcpy( Planety[4].soubor,"Data/planety_256x128x24/3Earth.bmp");
	strcpy( Planety[5].meno,"Mars");	strcpy( Planety[5].soubor,"Data/planety_256x128x24/4Mars.bmp");
	strcpy( Planety[6].meno,"Jupiter");	strcpy( Planety[6].soubor,"Data/planety_256x128x24/5Jupiter.bmp");
	strcpy( Planety[7].meno,"Saturn");	strcpy( Planety[7].soubor,"Data/planety_256x128x24/6Saturn.bmp");
	strcpy( Planety[8].meno,"Uran");	strcpy( Planety[8].soubor,"Data/planety_256x128x24/7Uran.bmp");
	strcpy( Planety[9].meno,"Neptun");	strcpy( Planety[9].soubor,"Data/planety_256x128x24/8Neptun.bmp");
	strcpy( Planety[10].meno,"Pluto");	strcpy( Planety[10].soubor,"Data/planety_256x128x24/9Pluto.bmp");

	//0 Vesmir
	Planety[0].r=5000; Planety[0].m=1;

	//1 Slunce
	Planety[1].r=10;
	Planety[1].m=332800;
	Planety[1].osa_rot=0;
	Planety[1].rot=5;

	TPlanety p1, p2=Planety[1];

	//2 Merkur
	p1=Planety[2];
	p1.r=0.03;
	p1.m=0.05;
	p1.pol.z=-30;
	p1.rych.x=p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=0;
	p1.rot=2;
	Planety[2]=p1;

	// Venuse
	p1=Planety[3];
	p1.r=0.09;
	p1.m=0.89;
	p1.pol.x=-70;
	p1.rych.z=-p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=1;
	p1.rot=0.05;
	Planety[3]=p1;

	//4 Zeme
	p1=Planety[4];
	p1.r=0.1;
	p1.m=1.0;
	p1.pol.z=100;
	p1.rych.x=-p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=-23.5;
	p1.rot=100.0;
	Planety[4]=p1;

	//5 Mars
	p1=Planety[5];
	p1.r=0.05;
	p1.m=0.11;
	p1.pol.x=150;
	p1.rych.z=p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=0;
	p1.rot=97.0;
	Planety[5]=p1;

	//6 Jupiter
	p1=Planety[6];
	p1.r=1.1;
	p1.m=318;
	p1.pol.z=-520;
	p1.rych.x=p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=45;
	p1.rot=243.0;
	Planety[6]=p1;

	//7 Saturn
	p1=Planety[7];
	p1.r=0.9;
	p1.m=95;
	p1.pol.x=-950;
	p1.rych.z=-p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=-45;
	p1.rot=233.0;
	Planety[7]=p1;

	//8 Uran
	p1=Planety[8];
	p1.r=0.4;
	p1.m=15;
	p1.pol.z=1920;
	p1.rych.x=-p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=90;
	p1.rot=133.0;
	Planety[8]=p1;

	//9 Neptun
	p1=Planety[9];
	p1.r=0.4;
	p1.m=17;
	p1.pol.x=3010;
	p1.rych.z=p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=0;
	p1.rot=124.0;
	Planety[9]=p1;

	//10 Pluto
	p1=Planety[10];
	p1.r=0.018;
	p1.m=0.002;
	p1.pol.z=-3950;
	p1.rych.x=p2.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p1.m+p2.m)));
	p1.osa_rot=0;
	p1.rot=374.0;
	Planety[10]=p1;

	// uz je zadana hmotnost p2..p10
	p1=Planety[2]; Planety[1].rych.x=-p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
	p1=Planety[3]; Planety[1].rych.z=+p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
	p1=Planety[4]; Planety[1].rych.x=+p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
	p1=Planety[5]; Planety[1].rych.z=-p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
	p1=Planety[6]; Planety[1].rych.x=-p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
	p1=Planety[7]; Planety[1].rych.z=+p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
	p1=Planety[8]; Planety[1].rych.x=+p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
	p1=Planety[9]; Planety[1].rych.z=-p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
	p1=Planety[10]; Planety[1].rych.x=-p1.m*sqrt(kapa/(vel_vekt( p2.pol.x-p1.pol.x, p2.pol.y-p1.pol.y, p2.pol.z-p1.pol.z)*(p2.m+p1.m)));
}
/**************************/

CVesmir::~CVesmir()
{
	glDeleteLists(list, poc_planet);
	glDeleteTextures(poc_planet,texture);
	gluDeleteQuadric(quadratic);				// Delete Quadratic - Free Resources
}

int CVesmir::InitObject(COGLfunc *ogll, int kvalita)
{
	CBaseObject::InitObject(ogll);

	glGenTextures(poc_planet, texture);
	for (int i=0; i<poc_planet; i++) if (Planety[i].m!=0)
		if ( !ogl->LoadGLTextures(texture[i],Planety[i].soubor) ) {
			sprintf(err,"%s c.: %d ze souboru: %s!",Planety[i].meno,i,Planety[i].soubor);
			MessageBox( NULL, err, "Nepodarilo se nacist texturu", MB_OK);
		}
	quadratic=gluNewQuadric();					// Create A Pointer To The Quadric Object ( NEW )
	if (!quadratic) MessageBox( NULL, "Neni dost pameti pro nacteni \"Quadratic Object\"", "Error", MB_OK);
	gluQuadricNormals(quadratic, GLU_SMOOTH);	// Create Smooth Normals ( NEW ), GLU_NONE, GLU_FLAT
	gluQuadricTexture(quadratic, GL_TRUE);		// Create Texture Coords ( NEW )
	BuildList();

	return 1;
}

void CVesmir::UpdateObjLogic(Uint8 *keys)
{
	if (keys[SDLK_KP_PLUS]) if (abs((int)deltat)<10) deltat*=1.1;
	if (keys[SDLK_KP_MINUS]) deltat/=1.1;
	if (keys[SDLK_KP_MULTIPLY]) {
		keys[SDLK_KP_MULTIPLY]=0;
		deltat*=-1;
	}
	if (keys[SDLK_F2]) { //ulozi soubor vesmir.ves
		keys[SDLK_F2]=0;
		FILE *File=NULL;
		File=fopen("Data/vesmir.ves","w");
		if (File) {
			fprintf(File,"poc_planet\t%d\n",poc_planet);
			fprintf(File,"deltat\t%Lf\n",deltat);
			fprintf(File,"kapa\t%Lf\n",kapa);
			fprintf(File,"//meno\tsoubor\tpolomer\thmotnost\tx\ty\tz\tvx\tvy\tvz\trotace\tosa_rotace\n");
			for ( int i=0; i<poc_planet; i++) if ( Planety[i].m!=0)
				fprintf(File,"ins\t%s\t%s\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\n",
					Planety[i].meno,Planety[i].soubor,Planety[i].r,Planety[i].m,
					Planety[i].pol.x,Planety[i].pol.y,Planety[i].pol.z,
					Planety[i].rych.x,Planety[i].rych.y,Planety[i].rych.z,
					Planety[i].rot,Planety[i].osa_rot);
			fclose(File);
		}
	}

	if (keys[SDLK_F3]) { //nacte soubor vesmir.ves
		keys[SDLK_F3]=0;
		FILE *File=NULL;
		char s[1000]; int planet=0,i=0;
		File=fopen("Data/vesmir.ves","r");
		if (File) {
			while (fscanf(File,"%s",s)!=EOF) {
				if (strcmp(s,"poc_planet")==0) fscanf(File," %d",&planet);
				if (strcmp(s,"deltat")==0) fscanf(File," %Lf",&deltat);
				if (strcmp(s,"kapa")==0) fscanf(File," %Lf",&kapa);
				if (s[0]=='/' && s[1]=='/') while (getc(File)!='\n');
				if (strcmp(s,"ins")==0) if (i<poc_planet) {
					fscanf(File,"%s\t%s\t%Lf\t%Lf\t%Lf\t%Lf\t%Lf\t%Lf\t%Lf\t%Lf\t%Lf\t%Lf\n",
						Planety[i].meno,Planety[i].soubor,&Planety[i].r,&Planety[i].m,
						&Planety[i].pol.x,&Planety[i].pol.y,&Planety[i].pol.z,
						&Planety[i].rych.x,&Planety[i].rych.y,&Planety[i].rych.z,
						&Planety[i].rot,&Planety[i].osa_rot);
					i++;
				}
			}
			for ( ; i<poc_planet; i++) { Planety[i].m=0; Planety[i].meno[0]=0; }
			fclose(File);
			//CVesmir::~CVesmir; tohle hlasi warning, tak sem dal ty 3 radky misto toho
			glDeleteLists(list, poc_planet);
			glDeleteTextures(poc_planet,texture);
			gluDeleteQuadric(quadratic);
			CVesmir::InitObject(ogl);
		}
	}

	double vel,dx,dy,dz,Fx,Fy,Fz,F;
	TPlanety p1, p2;
	for (int i=1/*aby se vynechal vesmir*/; i<poc_planet; i++) if (Planety[i].m!=0) {
		for (int j=i+1; j<poc_planet; j++) if (Planety[j].m!=0) {
			p1=Planety[i]; p2=Planety[j];

			dx= p2.pol.x - p1.pol.x;
			dy= p2.pol.y - p1.pol.y;
			dz= p2.pol.z - p1.pol.z;
			vel= sqrt(dx*dx+dy*dy+dz*dz);
			if ( vel>0 ) {
				/*	tohle je presne rozepsany podle vzorcu ( neskraceny, pomalejsi )
				F=kapa*p1.m*p2.m/(vel*vel);
				Fx=F*dx/vel; Fy=F*dy/vel; Fz=F*dz/vel;
				Planety[i].rych.x+= *Fx/p1.m;
				Planety[i].rych.y+= deltat*Fy/p1.m;
				Planety[i].rych.z+= deltat*Fz/p1.m;
				Planety[j].rych.x-= deltat*Fx/p2.m;
				Planety[j].rych.y-= deltat*Fy/p2.m;
				Planety[j].rych.z-= deltat*Fz/p2.m;*/
				F=kapa/(vel*vel*vel);
				Fx=F*dx; Fy=F*dy; Fz=F*dz;
				Planety[i].rych.x+= deltat*Fx*p2.m;
				Planety[i].rych.y+= deltat*Fy*p2.m;
				Planety[i].rych.z+= deltat*Fz*p2.m;
				Planety[j].rych.x-= deltat*Fx*p1.m;
				Planety[j].rych.y-= deltat*Fy*p1.m;
				Planety[j].rych.z-= deltat*Fz*p1.m;
			}
		}
		Planety[i].pol.x+=deltat*Planety[i].rych.x;
		Planety[i].pol.y+=deltat*Planety[i].rych.y;
		Planety[i].pol.z+=deltat*Planety[i].rych.z;
		celkemt+=deltat; if ( celkemt>20000) celkemt=0; //pokud by byl celkovy cas moc velky,
							//tak planety rotuji nepresne
	}
}

void CVesmir::UpdateObjDisplay()
{
	for (int i=0; i<poc_planet; i++) if (Planety[i].m!=0) {
		glPushMatrix();
			glTranslated(Planety[i].pol.x,Planety[i].pol.y,Planety[i].pol.z);
			ogl->glPrint3d(0,(float)Planety[i].r*1.5f,0,1,1,1,"%d. %s",i,Planety[i].meno);
			glRotated(Planety[i].osa_rot, 0, 0, 1);
			glRotated(Planety[i].rot*celkemt, 0, 1, 0);
			glCallList(list+i);
		glPopMatrix();
	}
}

void CVesmir::BuildList()
{
	//static GLfloat LightAmbient[]= { 0.01f, 0.01f, 0.01f, 1.0f }; //vsude
	static GLfloat LightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f }; //ze zdroje
	static GLfloat LightPosition[]= { 0.0f, 0.0f, 0.0f, 1.0f };				 // Light Position 

	list=glGenLists(poc_planet);

	glNewList(list,GL_COMPILE);			// New Compiled box Display List
		//glPolygonMode(GL_FRONT,GL_LINE);
		glBindTexture(GL_TEXTURE_2D, texture[0]);
		glRotated(90,-1,0,0);
		//glColor4f(1.0f,1.0f,1.0f,1.0f);
		gluQuadricOrientation(quadratic,GLU_INSIDE);	// aby slunce svitilo
		gluSphere(quadratic, Planety[0].r,16,16);		// Draw A Sphere
		gluQuadricOrientation(quadratic,GLU_OUTSIDE);
	glEndList();									// Done Building The box List
	glNewList(list+1,GL_COMPILE);			// New Compiled box Display List
		// svetlo
		//glLightfv(GL_LIGHT1, GL_AMBIENT, LightAmbient);		// Setup The Ambient Light
		glLightfv(GL_LIGHT1, GL_DIFFUSE, LightDiffuse);		// Setup The Diffuse Light
		glLightfv(GL_LIGHT1, GL_POSITION,LightPosition);	// Position The Light
		//glPolygonMode(GL_FRONT,GL_LINE);
		glBindTexture(GL_TEXTURE_2D, texture[1]);
		glRotated(90,-1,0,0);
		//glColor4f(1.0f,1.0f,1.0f,1.0f);
		gluQuadricOrientation(quadratic,GLU_INSIDE);	// aby slunce svitilo
		gluSphere(quadratic, Planety[1].r,16,16);		// Draw A Sphere
		gluQuadricOrientation(quadratic,GLU_OUTSIDE);
	glEndList();									// Done Building The box List

	for (int i=2; i<=10; i++) {
		glNewList(list+i,GL_COMPILE);			// New Compiled box Display List
			//glBindTexture(GL_TEXTURE_2D, 0);	// kdyz chci nejakou barvu
			glBindTexture(GL_TEXTURE_2D, texture[i]);
			glRotated(90,-1,0,0);
			//glColor4f(1.0f,1.0f,1.0f,1.0f);
			gluSphere(quadratic, Planety[i].r,16,16);		// Draw A Sphere
		glEndList();									// Done Building The box List
	}
}
