// Vesmir.h: interface for the CVesmir class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VESMIR_H__D0BECB20_E6A7_11D6_83E1_D8DE74F91425__INCLUDED_)
#define AFX_VESMIR_H__D0BECB20_E6A7_11D6_83E1_D8DE74F91425__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "main.h"
#include "BaseObject.h"
#define poc_planet 11	//Vesmir, Slunce, M, V, Z, M, J, S, U, N, P; je to maximalni pocet planet

class CVesmir : public CBaseObject
{
	void	BuildList();			// Build Box Display List
	GLUquadricObj	*quadratic;		// Storage For Our Quadratic Objects ( NEW )
	double	deltat,celkemt;			// cas
	double	kapa;		//6.67e-11;	// [Nm^2kg^-2]

public:
	CVesmir();
	virtual	~CVesmir();

	int		InitObject(COGLfunc *ogll, int kvalita=2);	// kvalita=0..2(nejlepsi));
	void	UpdateObjLogic(Uint8 *keys);
	void	UpdateObjDisplay();

	struct TPlanety {
		char meno[50], soubor[255];
		TSouradnice	pol,rych;		// poloha v m, rychlost jednotlivych teles v m/s
		double m, r, rot, osa_rot;	// hmotnost v kg, polomer v m, rychlost rotace, sklon osy rotace [stupne]
	}		Planety[poc_planet];

};

#endif // !defined(AFX_VESMIR_H__D0BECB20_E6A7_11D6_83E1_D8DE74F91425__INCLUDED_)
